;==============================================================================
;  Obsluga menu
;  Projekt:	Miernik energii i mocy na ADE7759
;==============================================================================

; 1) wiersz menu 8-bajtowy
; 2) flaga T sygnalizuje wykonanie dodatkowej akcji w calym danym podmenu
;    na podstawie adresu A1:A0 w opisie wiersza z bitem podmenu, jesli (A1:A0) <> 0
; 3) AD1:AD0 = 0xFFFF i BIT_PODMENU=1 to oznacza powrot do (pod)menu nadrzednego
;    (AD1:AD0 jest ustawiane w MENU_LEWO) - nalezy odczytac menu nadrzedne w stosunku do biezacego
;    aby pobrac adres funkcji dodatkowej

.equ	BIT_PODMENU		=7	; BIT_PODMENU na najstarszym bicie N (menu_numer)
.def	k0		=r0
.def	k1		=r1	; r1:r0 -adres komunikatu
.def	a0		=r2
.def	a1		=r3	; r3:r2 -adres akcji
.def	par0		=r4
.def	par1		=r5	; r5:r4 -parametry
.def	ad0		=r6
.def	ad1		=r7	; r7:r6 -adres dodatkowej akcji

.def	menu_poziom		=r18
.def	menu_numer		=r19

;rejestr Y zawiera biezacy adres w obszarze menu
;rejestr Z sluzy do wyswietlania tekstow na lcd

;    \/ -chyba jednak niekoniecznie, bo wyjscie z menu zaczyna proces (petle) od poczatku
; REJESTRY SA (musza byc) CHRONIONE (oprocz temp)
; temp i SREG jest juz chroniony w obsludze przerwania T0 (inne.asm)
.cseg
;==============================================================================
MENU:	; wejscie w menu - inicjalizacja
	push	k0
	push	k1
	push	a0
	push	a1
	push	par0
	push	par1
	push	ad0
	push	ad1
	push	yl
	push	yh
	push	zl
	push	zh
	clt
	clr	ad0
	clr	ad1

	rcall	LCD_CLEAR
	ldi	menu_poziom, 1	; menu_poziom = 1
	ldi	yl,  low(2*menu_kalibr)
	ldi	yh, high(2*menu_kalibr)
	sbrc	flagi, fKAL
	rjmp	M_KAL
	ldi	yl,  low(2*menu_start)
	ldi	yh, high(2*menu_start)
M_KAL:	sbiw	yl, 8		; (adres menu)-8 bo w MENU_DOL jest zwiekszany
	rjmp	MENU_DOL		; wyswietl

KLMN:	; detekcja, czy jest to pierwsze wejscie do procedury obslugi klawisza
	; zakladam, ze klawisze sa wciskane pojedynczo, z jakas przerwa miedzy jednym a drugim nacisnieciem
	wdr
	sbrc	flagi, fKLAW_WCIS	; przeskocz, jesli flaga wyzerowana
	rjmp	KLMN		; na poczatek petli

	lds	temp, Klawisze	; laduj zmienna o stanie klawiszy
	tst	temp
	breq	KLMN		; brak nacisniecia

	; rozpoznanie wcisnietego klawisza
	KLAWISZ_WCISNIETY		; ustaw bit wcisniecia klawisza
	sbrc	temp, KLAW_TAK	; przeskocz, jesli to nie klawisz TAK
	rjmp	MENU_TAK		; klawisz TAK wcisniety - zatwierdzenie
	sbrc	temp, KLAW_NIE
	rjmp	MENU_NIE		; wyjscie z (pod)menu
	sbrc	temp, KLAW_G
	rjmp	MENU_GORA
	sbrc	temp, KLAW_D
	rjmp	MENU_DOL
	sbrc	temp, KLAW_L
	rjmp	MENU_LEWO
	rjmp	MENU_PRAWO

KLMN_RET:	rcall	LCD_CLEAR
	clt
	pop	zh
	pop	zl
	pop	yh
	pop	yl
	pop	ad1
	pop	ad0
	pop	par1
	pop	par0
	pop	a1
	pop	a0
	pop	k1
	pop	k0
	ret


;------------------------------------------------------------------------------
MENU_DOL:	; strzalka w dol
	movw	zl, yl		; kopia biezacego adresu wiersza do Z
	; operacje musza byc na kopii (lpm Rd, Z)
MD_W:	adiw	zl, 8		; 8 bajtow dalej - nastepny wiersz
	lpm	temp, z		; pobierz Poziom
	cp	temp, menu_poziom	; porownanie z obecnym poziomem
	breq	MS_WYSW		;    rowny
	brlo	KLMN		;    mniejszy -> koniec (pod)menu
	rjmp	MD_W		;    wiekszy -> powtorz raz jeszcze

;------------------------------------------------------------------------------
MENU_GORA:	; strzalka w gore
	movw	zl, yl		; kopia biezacego adresu wiersza do Z
	movw	k0, menu_poziom	; kopia menu_*

	ldi	temp, 1<<BIT_PODMENU
	com	temp
	and	k1, temp		; czyszczenie bitu podmenu w kopii
	dec	k1		; jesli menu_numer-1 = 0 to oznacza
	breq	MG_SPR_P		; ...poczatek (pod)menu -> spr menu_poziom
	rjmp	MG_W
MG_SPR_P:	dec	k0		; dodatkowo jesli menu_poziom-1 = 0 to oznacza
	breq	KLMN		; ...poczatek menu

MG_W:	sbiw	zl, 8		; 8 bajtow wczesniej - poprzedni wiersz
	lpm	temp, z		; pobierz P
	cp	temp, menu_poziom	; porownanie z obecnym poziomem
	breq	MS_WYSW		;    rowny
	brlo	KLMN		;    mniejszy -> koniec (pod)menu
	rjmp	MG_W		;    wiekszy -> powtorz raz jeszcze

;----- wspolne dla DOL i GORA  --------
MS_WYSW:	; przejscie i wyswietlenie komunikatu
	movw	yl, zl		; nowy adres wiersza w menu
	adiw	zl, 1
	lpm	menu_numer, z+	; zmiana numeru
	lpm	k0, z+		; .
	lpm	k1, z+		; adres komunikatu
	lpm	a0, z+		; .
	lpm	a1, z+		; adres procedury (akcji)
	lpm	par0, z+		; .
	lpm	par1, z+		; parametry

	movw	zl, k0		; laduj adres komunikatu do Z
	rcall	LCD_CLEAR
	rcall	LCD_STR_FLASH	; wyswietl

	sbrc	menu_numer, BIT_PODMENU	; sprawdzenie bitu podmenu
	rjmp	MSW_P		; (bit podmenu)=1 --> jest podmenu
	; brak podmenu - sprawdzenie flagi dodatkowej akcji
	brtc	MSW_K		; flaga wyzerowana -> nie ma akcji
	movw	zl, ad0
	icall			; akcja wykonana
MSW_K:	rjmp	KLMN		; na poczatek petli
	; jest podmenu
MSW_P:	ldi	temp, LCD_LINE_2 | 13	; ustaw kursor na 14-tym znaku drugiej linii
	rcall	LCD_COMMAND
	ldi	temp, '>'		; symbol podmenu ">>>"
	rcall	LCD_CHAR
	rcall	LCD_CHAR
	rcall	LCD_CHAR

	ser	temp
	cp	ad0, temp
	cpc	ad1, temp		; czy AD1:AD0 = 0xFF ?
	breq	ML_AD		; ...tak -> powrot do MENU_LEWO
	rjmp	KLMN		; na poczatek petli


;------------------------------------------------------------------------------
MENU_LEWO:	; strzalka w lewo
	movw	k0, menu_poziom	; kopia menu_*
	dec	k0		; jesli menu_poziom-1 = 0 to oznacza
	breq	ML_M		; ...najwyzszy poziom

	dec	menu_poziom		; wchodzimy poziom wyej
	ldi	menu_numer, 2	; menu_numer wiekszy od 1 (nieistotne jaki numer)
	ser	temp
	mov	ad0, temp
	mov	ad1, temp		; AD1:AD0 = 0xFF --> oznacza powrot poziom wyzej
	rjmp	MENU_GORA		; i szukamy wiersza na wyzszym poziomie

ML_AD:	; pobieranie adresu akcji dodatkowej
	movw	k0, menu_poziom
	dec	k0
	breq	ML_AD_B		; najwyzszy poziom -> brak akcji dodatkowej

	; szukanie (pod)menu nadrzednego
	movw	zl, yl		; kopia biezacego adresu wiersza do Z
MLG_W:	sbiw	zl, 8		; 8 bajtow wczesniej - poprzedni wiersz
	lpm	temp, z		; pobierz P
	cp	temp, k0		; porownanie
	brne	MLG_W		;    nierowny (wiekszy)

	adiw	zl, 4		; ustaw na A0
	lpm	k0, z+		; adres procedury (akcji)
	lpm	k1, z		; ...wczytaj do K1:K0 (bo A1:A0 nie moze sie zmienic)
	clr	temp
	cp	k0, temp
	cpc	k1, temp		; czy k1:k0 <> 0 ?
	breq	ML_AD_B		; ...nie, =0
	set			; ...tak -> ustaw flage wykonania dodatkowej akcji po wyswietleniu wiersza menu
	movw	ad0, k0		; kopiuj adres akcji dodatkowej
	rjmp	KLMN		; na poczatek petli

ML_AD_B:	clt
	clr	ad0
	clr	ad1
ML_M:	rjmp	KLMN		; na poczatek petli

;------------------------------------------------------------------------------
MENU_PRAWO:	; strzalka w prawo
	sbrs	menu_numer, BIT_PODMENU
	rjmp	KLMN		; (bit podmenu)=0 --> brak podmenu
	; jest podmenu
	rjmp	MT_P

;------------------------------------------------------------------------------
MENU_TAK:	; klawisz TAK
	sbrs	menu_numer, BIT_PODMENU
	rjmp	MT_A		; (bit podmenu)=0 --> brak podmenu
	; jest podmenu
MT_P:	inc	menu_poziom		; poziom niej...
	clr	temp
	cp	a0, temp
	cpc	a1, temp		; czy A1:A0 <> 0 ?
	breq	MT_Z		; ...nie
	set			; ...tak -> ustaw flage wykonania dodatkowej akcji po wyswietleniu wiersza menu
	movw	ad0, a0		; kopiuj adres akcji dodatkowej
	rjmp	MENU_DOL		; i szukamy wiersza na nizszym poziomie
MT_Z:	clt			; kasuj flage wykonania dodatkowej akcji
	rjmp	MENU_DOL		; i szukamy wiersza na nizszym poziomie
	; wykonanie akcji
MT_A:	clr	temp
	cp	a0, temp
	cpc	a1, temp		; czy A1:A0 <> 0 ?
	breq	MT_K		; ...nie, =0
	movw	zl, a0		; zaladowanie adresu
	icall			; WYWOLANIE PROCEDURY OBSLUGI
MT_K:	rjmp	KLMN		; na poczatek petli


;------------------------------------------------------------------------------
MENU_NIE:	; klawisz NIE
	; calkowite wyjscie z MENU
	rjmp	KLMN_RET		; koniec






;==============================================================================
;   PROCEDURY OBSLUGI POSZCZEGOLNYCH WIERSZY MENU i PODMENU
; r1:r0 i zh:zl moga byc zmieniane, bo przechowuja adres komunikatu, ktory jest wyswietlany
; tylko raz po zmianie wiersza menu; inne trzeba chronic
;==============================================================================
M_ARM_W:	; ADE rejestr MODE -wyswietlanie biezacego stanu bitu
	; ZE ZMIENNYCH (nie z ADE7759)
	ldi	zl,  low(2*txt_ze)
	ldi	zh, high(2*txt_ze)
	lds	r0, Ade_mode
	lds	r1, Ade_mode+1
	and	r0, par0		; maska na odpowiedni bit
	and	r1, par1		; ...
	clr	temp
	cp	r0, temp
	cpc	r1, temp
	breq	MX_WYSW		; bit wyzerowany
	; bit ustawiony
	ldi	zl,  low(2*txt_us)
	ldi	zh, high(2*txt_us)

;------- wyswietlanie komunikatu - wspolne ------
MX_WYSW:	rcall	LCD_STR_FLASH	; wyswietl linie
	ret


;--------------------------------------
M_ARM:	; ADE rejestr MODE -zmiana bitow i wysylanie do ADE7759
	; par1:par0 -maska bitowa do zmiany [0-65535]
	push	r2
	push	r3
	push	xl
	push	xh
	lds	r0, Ade_mode
	lds	r1, Ade_mode+1
	movw	r2, r0		; kopia
	and	r2, par0		; maska na odpowiedni bit
	and	r3, par1		; ...
	clr	temp
	cp	r2, temp
	cpc	r3, temp
	breq	MARM_US		; bit wyzerowany -> ustaw
	; bit ustawiony -> zeruj
	movw	r2, par0		; kopia maski
	com	r2
	com	r3		; odwroc maski
	and	r0, r2
	and	r1, r3
	ldi	zl,  low(2*txt_ze)
	ldi	zh, high(2*txt_ze)
	rjmp	MARM_D
MARM_US:	or	r0, par0
	or	r1, par1
	ldi	zl,  low(2*txt_us)
	ldi	zh, high(2*txt_us)
MARM_D:
	push	r0
	push	r1		; zachowaj Ade_mode
	; rejestr MODE zmieniany w trybie kalibracji
	movw	xl, r0
	sbr	xl, 1<<M_DISSAG	; wylacz linie SAG
	sbr	xh, 1<<M_DTRT1
	cbr	xh, 1<<M_DTRT0	; ustaw zbieranie probek na 7kHz (140 na okres 50Hz)
	movw	r0, xl
	sts	Ade_mode, r0
	sts	Ade_mode+1, r1	; zapisz Ade_mode dla trybu kalibracji
	cli
	ldi	temp, ADE_MODE_ADR
	rcall	SPI_ADE_WRITE_2B	; temp -komenda; r1:r0 -2 bajty danych
	sei
	rcall	OIP		; przeliczenie ilosci: Probek_ile
	pop	r1
	pop	r0		; przywroc oryginal
	sts	Ade_mode, r0
	sts	Ade_mode+1, r1	; zapisz oryginal Ade_mode
	pop	xh
	pop	xl
	pop	r3
	pop	r2
	rjmp	MX_WYSW



;------------------------------------------------------------------------------
M_AOR_W:	; odczyt rejestrow ADE w drugiej linii LCD (nie trzeba zatwierdzac TAK)
	; par0 -adres rejestru, par1 -ilu bajtowy
	ldi	temp, LCD_LINE_2
	rcall	LCD_COMMAND
	mov	temp, par1
	cpi	temp, 2
	breq	MAORW_2B		; rejestr dwubajtowy
	mov	temp, par0
	cli
	rcall	SPI_ADE_READ_1B	; temp -komenda; r0 -1 bajt danych
	sei
	ldi	temp, 'h'
	rcall	HEX_1B
	ret
MAORW_2B:	mov	temp, par0
	cli
	rcall	SPI_ADE_READ_2B	; temp -komenda; r1:r0 -2 bajty danych
	sei
	ldi	temp, 'h'
	rcall	HEX_2B
	ret


;==============================================================================
M_AZR_W:	; podglad zmiennych (powiazane z M_AZR)
	; par1:par0 -adres danych
	rcall	ZE_HIST_ZERA
	in	r0, SREG
	push	r0
	movw	zl, par0
	lpm	r0, z+		; .
	lpm	r1, z+		; adres zmiennej do edycji
	adiw	zl, 5
	lpm	temp, z+		; liczba wysylanych bajtow
	movw	zl, r0		; adres zmiennej do z
	; sprawdzenie czy liczba w kodzie U2
	clt			; czysc flage liczby ze znakiem
	sbrc	temp, 7		; jesli r7(7)=1 to zmienna U2
	set			; ustaw flage liczby ze znakiem
	sbrc	temp, 1		; jesli r7(1)=1 to zmienna 2-bajtowa
	rjmp	MAZRW_2B
	; 1bajt
	ld	r0, z		; wczytaj wartosc zmiennej
	clr	r1
	brtc	MAZRW_PL		; jesli liczba w kodzie U2 to powiel bity znaku
	sbrs	r0, 7		; bit 7 informuje o liczbie ze znakiem
	rjmp	MAZRW_PL
	ser	temp
	mov	r1, temp		; bity znaku
	; 2bajty
MAZRW_2B:	ld	r0, z		; wczytaj wartosc zmiennej
	ldd	r1, z+1
MAZRW_PL:	rcall	WYSW_HEX_DEC_2B
	rcall	US_HIST_ZERA
	pop	r0
	out	SREG, r0
	ret


ZE_HIST_ZERA:
	lds	temp, Hist_zera_ile
	andi	temp, 0b01111111	; aby zmienna byla wyswietlana od 1
	sts	Hist_zera_ile, temp
	ret

US_HIST_ZERA:
	lds	temp, Hist_zera_ile
	ori	temp, 0x80
	sts	Hist_zera_ile, temp
	ret

;--------------------------------------
M_AZR:	; zmiana rejestrow ADE (oraz zmiennych) - odczyt ze zmiennej i wyslanie do ADE7759
	; par1:par0 -adres danych
	push	r2
	push	r3
	push	r4
	push	r5
	push	r6
	push	r7
	in	r0, SREG
	push	r0

	rcall	ZE_HIST_ZERA

	movw	zl, par0
	lpm	r0, z+		; .
	lpm	r1, z+		; adres zmiennej do edycji
	lpm	r2, z+		; .
	lpm	r3, z+		; min
	lpm	r4, z+		; .
	lpm	r5, z+		; max
	lpm	r6, z+		; adres rejestru w ADE
	lpm	r7, z+		; liczba wysylanych bajtow
	movw	zl, r0		; adres zmiennej do z
	; sprawdzenie czy liczba w kodzie U2
	clt			; czysc flage liczby ze znakiem
	sbrc	r7, 7		; jesli r7(7)=1 to zmienna U2
	set			; ustaw flage liczby ze znakiem

	sbrc	r7, 1		; jesli r7(1)=1 to zmienna 2-bajtowa
	rjmp	MAZR_2B1
	; 1bajt
	ld	r0, z		; wczytaj wartosc zmiennej
	clr	r1
	brtc	MAZR_PL		; jesli liczba w kodzie U2 to powiel bity znaku
	sbrs	r0, 7		; jesli r0(7)=1 to liczba ujemna
	rjmp	MAZR_PL
	ser	temp
	mov	r1, temp		; bity znaku
MAZR_PL:	rcall	EDYCJA
	ld	temp, z
	cp	r0, temp
	breq	MAZR_W		; identyczne --> brak zmiany
	st	z, r0
	rjmp	MAZR_ADE
	; 2bajty
MAZR_2B1:	ld	r0, z		; wczytaj wartosc zmiennej
	ldd	r1, z+1
	rcall	EDYCJA
	ld	temp, z
	cp	r0, temp
	ldd	temp, z+1
	cpc	r1, temp		; porownianie nowej wartosci z ta z RAM
	breq	MAZR_W		; identyczne --> brak zmiany
	st	z, r0
	std	z+1, r1		; zapisanie nowej wartosci

MAZR_ADE:	tst	r6
	breq	MAZR_W		; jesli r6=0, to nie wysylac do ADE

	sbrc	r7, 1		; jesli r7(1)=1 to zmienna 2-bajtowa
	rjmp	MAZR_2B2		; rejestr dwubajtowy
	mov	temp, r6
	cli
	rcall	SPI_ADE_WRITE_1B	; temp -komenda; r0 -1 bajt danych
	sei
	rjmp	MAZR_W
MAZR_2B2:	mov	temp, r6
	cli
	rcall	SPI_ADE_WRITE_2B	; temp -komenda; r1:r0 -2 bajty danych
	sei

MAZR_W:	;rcall	OIP	; obliczenie ilosci Probek_ile (przydatne tylko przy zmianie ilosci okresow)
	rcall	US_HIST_ZERA

	pop	r0
	out	SREG, r0
	pop	r7
	pop	r6	;wyn2
	pop	r5	;wyn1
	pop	r4	;wyn0
	pop	r3
	pop	r2
	rjmp	M_AZR_W


;--------------------------------------
PUST2:	; czyszczenie 2-go wiersza LCD
	ldi	temp, LCD_LINE_2
	rcall	LCD_COMMAND
	ldi	zl,  low(2*txt_pust)
	ldi	zh, high(2*txt_pust)	; czyszczenie 2-go wiersza
	rcall	LCD_STR_FLASH
	ret


MADE_W:	ldi	zl,  low(2*txt_zro)	; komunikat "Zrobione"
	ldi	zh, high(2*txt_zro)
	rjmp	MX_WYSW


;==============================================================================
M_ZR_W:	; podglad zmiennych z RAM (nie tylko zwiazanych z ADE7759)
	; par0 -adres zmiennej (low); par1 -ilu bajtowa
	in	r0, SREG
	push	r0
	; sprawdzenie czy liczba w kodzie U2
	clt			; czysc flage liczby ze znakiem
	sbrc	par1, 7		; jesli bit7=1 to zmienna U2
	set			; ustaw flage liczby ze znakiem

	sbrc	par1, 1		; jesli bit1=1 to zmienna 2-bajtowa
	rjmp	MZRW_2B
	; 1bajt
	mov	zl, par0
	clr	zh
	ld	r0, z		; wczytaj wartosc zmiennej
	clr	r1
	brtc	MZRW_PL		; jesli liczba w kodzie U2 to powiel bity znaku
	sbrs	par1, 7		; bit 7 informuje o liczbie ze znakiem
	rjmp	MZRW_PL
	ser	temp
	mov	r1, temp		; bity znaku

MZRW_2B:	mov	zl, par0
	clr	zh
	ld	r0, z+		; czytaj zmienna
	ld	r1, z
MZRW_PL:	rcall	WYSW_HEX_DEC_2B
	pop	r0
	out	SREG, r0
	ret


;------------------------------------------------------------------------------
M_OPC_W:	; rozne ustawienia -wyswietlanie
	; par1:par0 -adres parametrow
	push	r2
	push	r3
	push	r4
	push	r5
	rcall	PUST2

	movw	zl, par0		; adres danych
	lpm	r0, z+		; adres zmiennej
	lpm	r1, z+		; maska
	lpm	r2, z+
	lpm	r3, z+		; r3:r2 -adres komunikatu gdy bit=0
	lpm	r4, z+
	lpm	r5, z+		; r5:r4 -adres komunikatu gdy bit=1

	mov	zl, r0
	clr	zh
	ld	r0, z		; pobierz zmienna
	and	r0, r1		; maska na bit
	movw	zl, r2
	breq	MOPCW_ZE		; bit wyzerowany
	; bit ustawiony
	movw	zl, r4
MOPCW_ZE:	ldi	temp, LCD_LINE_2
	rcall	LCD_COMMAND
	rcall	LCD_STR_FLASH	; wyswietl linie

	pop	r5
	pop	r4
	pop	r3
	pop	r2
	ret


;--------------------------------------
M_OPC:	; Rozne ustawienia bitowe
	; par1:par0 -adres parametrow

	movw	zl, par0		; adres danych
	lpm	r0, z+		; adres zmiennej
	lpm	r1, z+		; maska

	mov	zl, r0
	clr	zh
	ld	r0, z		; pobierz zmienna
	mov	temp, r0		; kopia
	and	temp, r1		; maska na bit
	breq	MOPC_US		; bit wyzerowany -> ustaw
	; bit ustawiony -> zeruj
	com	r1		; odwroc maske
	and	r0, r1		; zeruje bit
	rjmp	MOPC_D
MOPC_US:	or	r0, r1		; ustawia bit
MOPC_D:	st	z, r0		; zapisz zmienna

	cli
	cbr	flagi, (1<<fTARYFY) | (1<<fTARYFA2)	; ustaw licznik jednotaryfowy i taryfe1
	lds	temp, Flagi2
	lsr	temp		; bit TARYFY do C
	brcc	MT0
	sbr	flagi, 1<<fTARYFY	; ustaw licznik dwutaryfowy
MT0:	rcall	SPRAWDZ_TARYFE

	push	ee_adr
	push	ee_dane
	lds	ee_dane, Flagi2
	ldi	ee_adr, (low(Flagi2) -RAM) +EEPROM
	rcall	EE_ZAPIS
MOPC_1:	sbic	EECR, EEWE		; czekaj koniec zapisu
	rjmp	MOPC_1
	pop	ee_dane
	pop	ee_adr

	sei
	rjmp	M_OPC_W		; odswiezenie LCD


;==============================================================================
DATACZAS:	; wyswietla date i czas na LCD (w jednej linii)
	; w rejestrze Z adres Bufora wypelnionego data i czasem
	ldi	temp, '2'
	rcall	LCD_CHAR
	ldi	temp, '0'
	rcall	LCD_CHAR
	ld	r0, z		; pobierz rok
	rcall	HEX_1B
	ldi	temp, '-'
	rcall	LCD_CHAR
	ldd	r0, z+1		; pobierz miesiac
	rcall	HEX_1B
	ldi	temp, '-'
	rcall	LCD_CHAR
	ldd	r0, z+2		; pobierz dzien
	rcall	HEX_1B

	ldi	temp, ' '
	rcall	LCD_CHAR
	ldd	r0, z+3		; pobierz godziny
	rcall	HEX_1B
	ldi	temp, ':'
	rcall	LCD_CHAR
	ldd	r0, z+4		; pobierz minuty
	rcall	HEX_1B
	ret

;------------------------------------------------------------------------------
M_CZAS:	; odczyt DS1307, wyswietlenie czasu i daty
	cli
	push	yl
	push	yh
	rcall	CZYTAJ_DS1307
	pop	yh
	pop	yl
	sei

	ldi	zl,  low(Bufor)
	ldi	zh, high(Bufor)
	lds	r0, Rok_bcd
	st	z, r0
	lds	r0, Miesiac_bcd
	std	z+1, r0
	lds	r0, Dzien_bcd
	std	z+2, r0
	lds	r0, Godziny_bcd
	std	z+3, r0
	lds	r0, Minuty_bcd
	std	z+4, r0

	rcall	LCD_CLEAR
	rcall	DATACZAS

	ldi	temp, LCD_LINE_2
	rcall	LCD_COMMAND
	lds	temp, Dzien_tyg
MC_DNI:	push	r0
	push	r1
	push	zl
	push	zh
	ldi	zl,  low(da_dni)	; adres (word-1) do tabeli adresow dni tygodnia
	ldi	zh, high(da_dni)
	add	zl, temp		; dodanie dnia tygodnia: 1-Pn., 7-Nd
	clr	temp
	adc	zh, temp
	lsl	zl
	rol	zh		; adres*2 aby wczytywac bajty
	lpm	r0, z+
	lpm	r1, z+		; pobranie adresu (word) do wybranego dnia tyg.
	movw	zl, r0		; adres do Z
	rcall	LCD_STR_FLASH	; wyswietl linie
	pop	zh
	pop	zl
	pop	r1
	pop	r0
	ret


;------------------------------------------------------------------------------
M_CZAS_ED:	; edycja zmiennych daty lub czasu w formacie BCD
	; par1:par0 -poczatek serii danych do edycji
	push	r2
	push	r6	;bin0
	push	r18	;bcd0
	push	r19	;bcd1
	push	yl
	push	yh

	ldi	temp, LCD_D1_C0_B1
	rcall	LCD_COMMAND
	movw	zl, par0		; adres pierwszej danej do z

MCE_ZN:	lpm	yl, z+		; adres zmiennej w Y
	clr	yh
	ld	bcd0, y		; wartosc zmiennej...
	rcall	BCD_8_BIN		; ...w bin0
	lpm	r0, z+		; min
	lpm	r1, z+		; max
	lpm	r2, z+		; numer znaku na LCD
	rcall	MCE_KUR		; umiesc kursor we wlasciwym miejscu
	sbiw	zl, 4

	rjmp	MCE_LCD

;--------
MCE_KL:	wdr
	; detekcja dlugiego trzymania klawisza
	sbrc	flagi, fOVER_I
	rjmp	MCE_KL_DL

	; detekcja, czy jest to pierwsze wejscie do procedury obslugi klawisza
	sbrc	flagi, fKLAW_WCIS	; przeskocz, jesli flaga wyzerowana
	rjmp	MCE_KL		; na poczatek petli

	lds	temp, Klawisze	; laduj zmienna o stanie klawiszy
	tst	temp
	breq	MCE_KL		; brak nacisniecia

	; rozpoznanie wcisnietego klawisza
	KLAWISZ_WCISNIETY		; ustaw bit wcisniecia klawisza
	sbrc	temp, KLAW_TAK	; przeskocz, jesli to nie klawisz TAK
	rjmp	MCE_TAK		; klawisz TAK wcisniety - zatwierdzenie
	sbrc	temp, KLAW_NIE
	rjmp	MCE_NIE
	sbrc	temp, KLAW_L
	rjmp	MCE_LEWO
	sbrc	temp, KLAW_P
	rjmp	MCE_PRAWO
MCE_KL_DL:	lds	temp, Klawisze
	cbr	flagi, 1<<fOVER_I	; zeruj flage dlugiego wcisniecia klawisza
	sbrc	temp, KLAW_G
	rjmp	MCE_GORA
	sbrc	temp, KLAW_D
	rjmp	MCE_DOL
	rjmp	MCE_KL		; na poczatek petli

;--------
MCE_TAK:	; zatwierdzenie zmiany: z=0xFFFF
	ldi	zl, 0xFF
	mov	zh, zl
	rjmp	MCE_K
MCE_NIE:	; anulowanie zmiany z=0
	ldi	zl, 0
	mov	zh, zl
MCE_K:	ldi	temp, LCD_D1_C0_B0
	rcall	LCD_COMMAND
	pop	yh
	pop	yl
	pop	r19
	pop	r18
	pop	r6
	pop	r2
	ret


	; edycja zmiennej w bin0
MCE_GORA:	; zwiekszenie liczby o 1 jesli mozliwe
	cp	bin0, r1
	brlo	MCEG_A		; mniejsza  --> zwiekszenie
	rjmp	MCE_KL		; na poczatek petli
MCEG_A:	ldi	temp, 1		; +1
	tst	bin0
	brne	MCEG_B
	sbr	flagi, 1<<fOVER_U
MCEG_B:	add	bin0, temp
	rjmp	MCE_LCD		; dane sie zmienily

MCE_DOL:	; zmniejszenie liczby o 1 jesli mozliwe
	cp	r0, bin0
	brlo	MCED_A		; mniejsza  --> zwiekszenie
	rjmp	MCE_KL		; na poczatek petli
MCED_A:	ldi	temp, 1		; -1
	sub	bin0, temp
	rjmp	MCE_LCD		; dane sie zmienily

MCE_LEWO:	; zmiana zmiennej do edycji
	cp	par0, zl
	cpc	par1, zh		; czy mozna wybrac wczesniejsza zmienna?
	brlo	MCEL_A
	rjmp	MCE_KL		; na poczatek petli
MCEL_A:	sbiw	zl, 4		; poprzednia zmienna
	rjmp	MCE_ZN		; zmien wskaznik na LCD

MCE_PRAWO:	; zmiana zmiennej do edycji
	sbrc	r2, 7		; bit7 numeru_znaku_lcd oznacza koniec danych
	rjmp	MCE_KL		; na poczatek petli
MCEP_A:	adiw	zl, 4		; nastepna zmienna
	rjmp	MCE_ZN		; zmien wskaznik na LCD

;--------------------------------------
MCE_LCD:	mov	temp, r1
	cpi	temp, 7		; spr. czy wyswietlic dzien tygodnia (max.=7)
	brne	MCELCD_1		; <>7 --> liczba
	st	y, bin0		; zapis Dzien_tyg
	movw	bcd0, zl		; ochrona Z
	sbrs	flagi, fOVER_U
	rjmp	MCELDNI
	ldi	zl,  low(2*txt_pust)	; czyszczenie spacjami
	ldi	zh, high(2*txt_pust)
	rcall	LCD_STR_FLASH
	rcall	MCE_KUR
	cbr	flagi, 1<<fOVER_U
MCELDNI:	mov	temp, bin0
	rcall	MC_DNI		; wyswietl nazwe dnia tyg.
	rcall	MCE_KUR		; kursor na miejsce edycji
	movw	zl, bcd0
	rjmp	MCE_KL		; na poczatek petli

MCELCD_1:	mov	bcd0, bin0
	rcall	BIN_7_BCD
	mov	temp, bcd1
	swap	temp
	or	temp, bcd0		; pakowanie liczby BCD
	st	y, temp		; zapis zmiennej w RAM
	ori	bcd0, 0b00110000	; poprawne ustawienie cyfry w tablicy znakow
	ori	bcd1, 0b00110000
	ldi	temp, LCD_CURSOR_LEFT
	rcall	LCD_COMMAND
	mov	temp, bcd1
	rcall	LCD_CHAR
	mov	temp, bcd0
	rcall	LCD_CHAR
	ldi	temp, LCD_CURSOR_LEFT
	rcall	LCD_COMMAND
	rjmp	MCE_KL		; na poczatek petli

;--------------------------------------
MCE_KUR:	mov	temp, r2
	andi	temp, 0b01111111	; maskuj bit konca serii
	ori	temp, LCD_LINE_1
	rcall	LCD_COMMAND		; kursor na miejsce edycji
	ret


;------------------------------------------------------------------------------
M_DACZ:	; edycja daty i czasu
	rcall	M_CZAS_ED		; par1:par0 -dane
	; rejestr Z zawiera status wykonania:
	cpi	zh, 0xFF
	brne	MDC_NIE
	; zatwierdzenie zmiany
	cli
	push	yl
	push	yh
	rcall	USTAW_DS1307_ALL
	pop	yh
	pop	yl
	sei
	;rcall	SPRAWDZ_TARYFE	; w USTAW_DS1307_ALL
	rcall	DELAY_44us
MDC_NIE:	; anulowanie zmiany
	rcall	M_CZAS		; wyswietlenie (starego, jesli _NIE) czasu
	ret


;==============================================================================
M_EN_O_W:	; wyswietlenie zakresu czasu akumulacji Energia_od
	ldi	zl,  low(Od_rok_st)
	ldi	zh, high(Od_rok_st)
	rcall	LCD_CLEAR
	rcall	DATACZAS
	ret

;==============================================================================
M_EN_OO_W:	; wyswietlenie zakresu czasu akumulacji Energia_oddo
	push	yl
	push	yh
	ldi	zl,  low(Bufor)
	ldi	zh, high(Bufor)
	rcall	LCD_CLEAR
	ldi	yl,  low(Oddo_rok_st)	; najpierw zakres start
	ldi	yh, high(Oddo_rok_st)
	ldi	temp, 2
	mov	r1, temp

MEOW:	ld	r0, y
	st	z, r0
	ldd	r0, y+2
	std	z+1, r0
	ldd	r0, y+4
	std	z+2, r0
	ldd	r0, y+6
	std	z+3, r0
	ldd	r0, y+8
	std	z+4, r0
	rcall	DATACZAS

	adiw	yl, 1		; potem zakres stop w drugiej linii
	ldi	temp, LCD_LINE_2
	rcall	LCD_COMMAND

	dec	r1
	brne	MEOW

	pop	yh
	pop	yl
	ret


;------------------------------------------------------------------------------
CZASED:	; zmiana zakresu czasu ...
	; 'temp' zawiera ilosc zmiennych do edycji
	; oraz 'temp' zwraca 0xFF jesli TAK
	push	yl
	push	yh
	push	r22
	mov	r22, temp		; ilosc zmiennych do edycji -kopia

	movw	zl, par0		; adres pierwszej danej do z
	clr	yh
CZD_N:	lpm	yl, z		; adres zmiennej do Y
	ld	r0, y
	push	r0		; zmienna na stos (ochrona przed anulowaniem)
	adiw	zl, 4
	dec	temp
	brne	CZD_N
	push	zl
	push	zh

	rcall	M_CZAS_ED		; par1:par0 -dane
	; rejestr Z zawiera status wykonania:
	cpi	zh, 0xFF
	pop	zh
	pop	zl
	breq	CZD_TAK
	; anulowanie
	mov	temp, r22
CZD_POP:	sbiw	zl, 4
	lpm	yl, z
	pop	r0		; zdejmij ze stosu i zapisz
	st	y, r0		; ...stare wartosci
	dec	temp
	brne	CZD_POP
	rjmp	CZD_K
CZD_TAK:	; jest zatwierdzenie
	mov	temp, r22
CZD_TP:	pop	r0
	dec	temp
	brne	CZD_TP
	ser	temp

CZD_K:	pop	r22
	pop	yh
	pop	yl
	ret


;------------------------------------------------------------------------------
M_EN_O:	; zmiana zakresu czasu akumulacji Energia_od
	ldi	temp, 5
	rcall	CZASED
	cpi	temp, 0xFF
	brne	MENO_NIE
	; zatwierdzenie
	rcall	POROWNAJ_CZAS
	ldi	zl,  low(Energia1_od)
	ldi	zh, high(Energia1_od)
	cli
	rcall	CZYSC_ENERG
	rcall	ZAPISZ_EO_EE
	sei
MENO_NIE:	rjmp	M_EN_O_W

;------------------------------------------------------------------------------
M_EN_OO:	; zmiana zakresu czasu akumulacji Energia_oddo
	ldi	temp, 10
	rcall	CZASED
	cpi	temp, 0xFF
	brne	MENOO_NIE
	; zatwierdzenie
	rcall	POROWNAJ_CZAS
	ldi	zl,  low(Energia1_oddo)
	ldi	zh, high(Energia1_oddo)
	cli
	rcall	CZYSC_ENERG
	rcall	ZAPISZ_EOO_EE
	sei
MENOO_NIE:	rjmp	M_EN_OO_W



;------------------------------------------------------------------------------
M_TAR2:	; wyswietlenie zakresu godzin taryfy2
	push	yl
	push	yh

	ldi	temp, ' '
	rcall	LCD_CHAR
	rcall	LCD_CHAR

	movw	zl, par0		; adres pierwszej danej do z
	lpm	yl, z		; adres zmiennej do Y
	clr	yh
	adiw	zl, 4
	ld	temp, y		; wartosc dzien_start
	rcall	MC_DNI
	ld	temp, y
	tst	temp		; jesli dzien_start=0 to ten zakres nieaktywny
	breq	MT2_WL

	ldi	temp, '-'
	rcall	LCD_CHAR
	lpm	yl, z
	ld	temp, y		; dzien_stop
	rcall	MC_DNI

MT2_WL:	ldi	temp, LCD_LINE_2
	rcall	LCD_COMMAND
	adiw	zl, 4
	lpm	yl, z
	ld	r0, y		; godz_st
	rcall	HEX_1B
	ldi	temp, ':'
	rcall	LCD_CHAR
	adiw	zl, 4
	lpm	yl, z
	ld	r0, y		; minuty_st
	rcall	HEX_1B
	ldi	temp, '-'
	rcall	LCD_CHAR
	adiw	zl, 4
	lpm	yl, z
	ld	r0, y		; godz_sp
	rcall	HEX_1B
	ldi	temp, ':'
	rcall	LCD_CHAR
	adiw	zl, 4
	lpm	yl, z
	ld	r0, y		; minuty_st
	rcall	HEX_1B

	pop	yh
	pop	yl
	ret


;------------------------------------------------------------------------------
M_TAR2ED:	; edycja zakresu godzin taryfy2
	ldi	temp, 6
	rcall	CZASED
	cpi	temp, 0xFF
	brne	MT2E_NIE
	; jest zatwierdzenie
	cli
	rcall	SPRAWDZ_TARYFE
	rcall	ZAPISZ_TAR_EE
	sei
MT2E_NIE:	ldi	temp, LCD_LINE_1 | 2
	rcall	LCD_COMMAND
	rjmp	M_TAR2


;------------------------------------------------------------------------------
M_CZEN:	; zeruje akumulator energii: par1:par0
	ldi	zl,  low(2*txt_jp)	; "czy na pewno?"
	ldi	zh, high(2*txt_jp)
	rcall	LCD_STR_FLASH	; wyswietl linie

MCZEN_KL:	wdr
	sbrc	flagi, fKLAW_WCIS	; przeskocz, jesli flaga wyzerowana
	rjmp	MCZEN_KL		; na poczatek petli
	lds	temp, Klawisze	; laduj zmienna o stanie klawiszy
	tst	temp
	breq	MCZEN_KL		; brak nacisniecia
	; rozpoznanie wcisnietego klawisza
	KLAWISZ_WCISNIETY		; ustaw bit wcisniecia klawisza
	sbrc	temp, KLAW_TAK	; przeskocz, jesli to nie klawisz TAK
	rjmp	MCZEN_TAK		; klawisz TAK wcisniety - zatwierdzenie
	sbrc	temp, KLAW_NIE
	rjmp	PUST2
	rjmp	MCZEN_KL		; na poczatek petli
MCZEN_TAK:
	movw	zl, par0
	cli
	rcall	CZYSC_ENERG
	rcall	ZAP_EN_DS1307
	sei
	rjmp	MADE_W		; komunikat "Zrobione"


;------------------------------------------------------------------------------
M_ZEN:	; zapisuje energie z RAM do EEPROMu
	cli
	rcall	ZAPISZ_EN_EE
	sei
	rjmp	MADE_W		; komunikat "Zrobione"

;------------------------------------------------------------------------------
M_CEN:	; odczytuje energie z EEPROM do RAM (przydatne np. po wymianie baterii)
	cli
	rcall	CZYTAJ_EN_EE
	rcall	ZAP_EN_DS1307
	sei
	rjmp	MADE_W		; komunikat "Zrobione"

;------------------------------------------------------------------------------
M_ZEE:	; zapisuje konfiguracje do EEPROMu
	cli
	rcall	ZAPISZ_KONF_EE
	sei
	rjmp	MADE_W		; komunikat "Zrobione"

;--------------------------------------
M_IE:	; ustawienie komorki 2h EEPROM na wartosc 150 (nie zeruj energii)
	; potem RESET
	cli
	ldi	ee_adr, 4		; testowana komorka pamieci
	ldi	ee_dane, 150	; wartosc inna niz 74 ==> zapisz
	rcall	EE_ZAPIS		; ...eeprom wartosciami domyslnymi
MIE_1:	sbic	EECR, EEWE		; czekaj koniec zapisu
	rjmp	MIE_1
	rjmp	RESET


;==============================================================================
;==============================================================================
M_K_I:	; kalibracja zera dla pradu
	cli
	ldi	temp, ADE_CH1OS_ADR
	clr	r0
	sts	Ade_ch1os, r0
	rcall	SPI_ADE_WRITE_1B	; Ade_ch1os
	sei
	clr	temp
	ldi	zl,  low(Off_I_dc)
	ldi	zh, high(Off_I_dc)
	rcall	MKDC_ZER

	ldi	zl,  low(Off_x1)
	ldi	zh, high(Off_x1)
	rcall	MKDC_ZER
	ldi	temp, CYKLI_POM	; ilosc cykli pomiarowych (czyli ilosc sekund)
	std	z+4, temp
	ser	temp
	st	z, temp
	std	z+1, temp		; poniewaz pierwsza jest wykonywana kalibracja CH?OS

	ldi	temp, (1<<f4KAL_DCI) | (1<<f4KAL_CH) | (1<<f4KAL_CH0)
MK_NIE:	sts	Flagi4, temp

	KLAWISZ_PUSZCZONY
	ldi	temp, 1<<KLAW_NIE
	sts	Klawisze, temp	; wyjscie z menu
	ret

;--------------------------------------
M_K_U:	; kalibracja zera dla napiecia
	lds	r0, Napiecie_rms
	lds	r1, Napiecie_rms+1
	ldi	zl,  low(100)
	ldi	zh, high(100)	; amplituda do detekcji podlaczenia do sieci
	cp	r0, zl
	cpc	r1, zh
	brlo	MKU_Z
	ldi	zl,  low(2*txt_zdn)	; komunikat "Za duze napiecie"
	ldi	zh, high(2*txt_zdn)
	rcall	LCD_STR_FLASH	; wyswietl linie
	ret

MKU_Z:	cli
	ldi	temp, ADE_CH2OS_ADR
	clr	r0
	sts	Ade_ch2os, r0
	rcall	SPI_ADE_WRITE_1B	; Ade_ch2os
	sei
	clr	temp
	ldi	zl,  low(Off_U_dc)
	ldi	zh, high(Off_U_dc)
	rcall	MKDC_ZER

	ldi	zl,  low(Off_x1)
	ldi	zh, high(Off_x1)
	rcall	MKDC_ZER
	ldi	temp, CYKLI_POM	; ilosc cykli pomiarowych (czyli ilosc sekund)
	std	z+4, temp
	ser	temp
	st	z, temp
	std	z+1, temp		; poniewaz pierwsza jest wykonywana kalibracja CH?OS

	ldi	temp, (1<<f4KAL_DCU) | (1<<f4KAL_CH) | (1<<f4KAL_CH0)
	rjmp	MK_NIE


;--------------------------------------
M_K_E:	; kalibracja zera dla energii
	cli
	ldi	zl,  low(Energia1_ses)
	ldi	zh, high(Energia1_ses)
	rcall	CZYSC_ENERG		; czysci energie tymczasowa
	clr	r0
	clr	r1
	sts	Ade_apos, r0
	sts	Ade_apos+1, r0
	ldi	temp, ADE_APOS_ADR
	rcall	SPI_ADE_WRITE_2B
	sei
	ldi	temp, CYKLI_POM
	sts	Cykli, temp
	ldi	temp, 1<<f4KAL_E
	rjmp	MK_NIE


;--------------------------------------
MKDC_ZER:	st	z, temp		; zerowanie offsetow
	std	z+1, temp
	std	z+2, temp
	std	z+3, temp
	std	z+4, temp
	ret







.exit
;==============================================================================

Struktura menu:

1	"menu1"
   11	"podmenu1"
   12	"podmenu1"
   13	"podmenu1"
2	"menu2"
3	"menu3"
   31	"podmenu3"
   32	"podmenu3"
      321	"podmenu32"
      322	"podmenu32"
      323	"podmenu32"
   33	"podmenu3"
   34	"podmenu3"
4	"menu4"
   41	"podmenu4"
   42	"podmenu4"

----poziom--->

zapisana jest kolejno za pomoca liczb "poziom" i "numer":
P: poziom zaglebienia w strukturze menu,
N: numer kolejny na danym poziomie

P  N
----
1  1	"menu1"
2  1	"podmenu1"
2  2	"podmenu1"
2  3	...

1  2

1  3
2  1
2  2
3  1
3  2
3  3
2  3
2  4

1  4
2  1
2  2

0  0	KONIEC

Kazdy wiersz zawiera rowniez dwubajtowy adres komunikatu do wyswietlenia oraz
dwubajtowy adres procedury ktora zostanie wykonana (skok lub call) po zatwierdzeniu wyboru
oraz dwa bajty parametrow.

P  N  K0 K1 A0 A1 P0 P1

P: poziom zaglebienia w strukturze menu,
N: numer kolejny na danym poziomie
K1:K0 -adres komunikatu
A1:A0 -adres procedury obslugi wiersza (wykonywanej po nacisnieciu TAK)
P1:P0 -parametry (np. dla procedury)

Dzieki temu przeszukiwanie struktury menu jest proste.
Dodatkowo najstarszy bit liczby N (menu_numer) informuje czy dany wiersz ma podmenu (aby rozroznic
wejscie do podmenu lub wykonanie akcji)

Jesli bit podmenu jest ustawiony, to przy wchodzeniu do tego podmenu sprawdzany jest adres A1:A0
- jesli adres <> 0 to wykonywana jest akcja dla calego podmenu (z wyjatkiem wierszy z ustawionym bitem podmenu)
Pozwala to juz przy wejsciu do podmenu podgladac np. wartosci zmiennych.
